#include "GameEnums.h"
#include "Base.h"

// keep in sync with enum Layers
static const char *s_LayerNames[LR_MAX] =
{
	"LR_ZERO",
	"LR_BACKDROP",
	"LR_BACKGROUND",
	"LR_SCENEBACKGROUNDIMAGE",
	"LR_BACKDROP_ELEMENTS1",
	"LR_BACKDROP_ELEMENTS2",
	"LR_ENTITIES_MINUS4_PLACEHOLDER",
	"LR_BACKDROP_ELEMENTS3",
	"LR_BACKDROP_ELEMENTS4",
	"LR_BACKDROP_ELEMENTS5",
	"LR_BACKDROP_ELEMENTS6",
	"LR_BACKGROUND_ELEMENTS1",
	"LR_BACKGROUND_ELEMENTS2",
	"LR_ENTITIES_MINUS3_PLACEHOLDER",
	"LR_BACKGROUND_ELEMENTS3",
	"LR_ENTITIES_MINUS2_PLACEHOLDER",
	"LR_BLACKGROUND",
	"LR_UPDATE_ELEMENTS_BG",
	"LR_ELEMENTS1",
	"LR_ELEMENTS2",
	"LR_ELEMENTS3",
	"LR_ELEMENTS4",
	"LR_ELEMENTS5",
	"LR_ELEMENTS6",
	"LR_ELEMENTS7",
	"LR_ELEMENTS8",
	"LR_ELEMENTS9",
	"LR_ELEMENTS10",
	"LR_ELEMENTS11",
	"LR_ELEMENTS12",
	"LR_ELEMENTS13",
	"LR_ELEMENTS14",
	"LR_ELEMENTS15",
	"LR_ELEMENTS16",
	"LR_UPDATE_ELEMENTS_FG",
	"LR_ENTITIES_MINUS4",
	"LR_ENTITIES_MINUS3",
	"LR_ENTITIES_MINUS2",
	"LR_ENTITIES00",
	"LR_ENTITIES0",
	"LR_ENTITIES",
	"LR_ENTITIES2",
	"LR_WATERSURFACE",
	"LR_WATERSURFACE2",
	"LR_DARK_LAYER",
	"LR_PROJECTILES",
	"LR_LIGHTING",
	"LR_PARTICLES",
	"LR_PARTICLES2",
	"LR_FOREGROUND_ELEMENTS1",
	"LR_FOREGROUND_ELEMENTS2",
	"LR_PARTICLES_TOP",
	"LR_AFTER_EFFECTS",
	"LR_SCENE_COLOR",
	"LR_MENU",
	"LR_MENU2",
	"LR_HUD",
	"LR_HUD2",
	"LR_HUD3",
	"LR_HUDUNDERLAY",
	"LR_MINIMAP",
	"LR_RECIPES",
	"LR_WORLDMAP",
	"LR_WORLDMAPHUD",
	"LR_REGISTER_TEXT",
	"LR_DAMAGESPRITE",
	"LR_HELP",
	"LR_TRANSITION",
	"LR_OVERLAY",
	"LR_FILEMENU",
	"LR_CONFIRM",
	"LR_CURSOR",
	"LR_SUBTITLES",
	"LR_PROGRESS",
	"LR_DEBUG_TEXT",
	"LR_BLACKBARS"
};

const char *EnumName(Layers lr)
{
	compile_assert(Countof(s_LayerNames) == LR_MAX);

	return lr < Countof(s_LayerNames) ? s_LayerNames[lr] : NULL;
}

const char *s_AquariaActionNames_0[ACTION_MAX] =
{
	"ACTION_PRIMARY",
	"ACTION_SECONDARY",
	"ACTION_ESC",
	"ACTION_TOGGLESCENEEDITO",
	"ACTION_TOGGLEWORLDMAP",
	"ACTION_TOGGLEGRID",
	"ACTION_MENULEFT",
	"ACTION_MENURIGHT",
	"ACTION_MENUUP",
	"ACTION_MENUDOWN",
	"ACTION_PREVPAGE",
	"ACTION_NEXTPAGE",
	"ACTION_COOKFOOD",
	"ACTION_FOODLEFT",
	"ACTION_FOODRIGHT",
	"ACTION_FOODDROP",
	"ACTION_TOGGLEMENU"
};

const char *s_AquariaActionNames_100[ACTION_MAX] =
{
	"ACTION_SWIMUP",
	"ACTION_SWIMDOWN",
	"ACTION_SWIMLEFT",
	"ACTION_SWIMRIGHT",
	"ACTION_SINGUP",
	"ACTION_SINGDOWN",
	"ACTION_SINGLEFT",
	"ACTION_SINGRIGHT",
	"ACTION_SONGSLOT1",
	"ACTION_SONGSLOT2",
	"ACTION_SONGSLOT3",
	"ACTION_SONGSLOT4",
	"ACTION_SONGSLOT5",
	"ACTION_SONGSLOT6",
	"ACTION_SONGSLOT7",
	"ACTION_SONGSLOT8",
	"ACTION_SONGSLOT9",
	"ACTION_SONGSLOT10",
	"ACTION_SONGSLOTEND",
	"ACTION_ROLL",
	"ACTION_SLOW",
	"ACTION_REVERT"
};

const char *s_AquariaActionNames_200[ACTION_MAX] =
{
	"ACTION_ZOOMIN",
	"ACTION_ZOOMOUT",
	"ACTION_CAMLEFT",
	"ACTION_CAMRIGHT",
	"ACTION_CAMUP",
	"ACTION_CAMDOWN",
	"ACTION_BONELEFT",
	"ACTION_BONERIGHT",
	"ACTION_BONEUP",
	"ACTION_BONEDOWN",
	"ACTION_BGLAYER1",
	"ACTION_BGLAYER2",
	"ACTION_BGLAYER3",
	"ACTION_BGLAYER4",
	"ACTION_BGLAYER5",
	"ACTION_BGLAYER6",
	"ACTION_BGLAYER7",
	"ACTION_BGLAYER8",
	"ACTION_BGLAYER9",
	"ACTION_BGLAYER10",
	"ACTION_BGLAYER11",
	"ACTION_BGLAYER12",
	"ACTION_BGLAYER13",
	"ACTION_BGLAYER14",
	"ACTION_BGLAYER15",
	"ACTION_BGLAYER16",
	"ACTION_BGLAYEREND",
	"ACTION_MULTISELECT",
	"ACTION_TOGGLEWORLDMAPEDITOR",
	"ACTION_LOOK",
	"ACTION_TOGGLEHELPSCREEN",
	"ACTION_PLACE_AVATAR",
	"ACTION_SCREENSHOT"
};

const char *EnumName(AquariaActions a)
{
	unsigned i = a;
	if(i < Countof(s_AquariaActionNames_0))
		return s_AquariaActionNames_0[i];
	i -= 100; // no problem if this underflows
	if(i < Countof(s_AquariaActionNames_100))
		return s_AquariaActionNames_100[i];
	i -= 100;
	if(i < Countof(s_AquariaActionNames_200))
		return s_AquariaActionNames_200[i];

	return NULL;
}
